/*
 * ioctl defines
 */

#define	DFS_MUTE_TIME		1
#define	DFS_SET_THRESH		2
#define	DFS_GET_THRESH		3
#define	DFS_GET_USENOL		4
#define DFS_SET_USENOL		5
#define DFS_RADARDETECTS	6
#define	DFS_BANGRADAR		7 

/* 
 * ioctl parameter types
 */

#define	DFS_PARAM_FIRPWR	1
#define	DFS_PARAM_RRSSI		2
#define	DFS_PARAM_HEIGHT	3
#define	DFS_PARAM_PRSSI		4
#define	DFS_PARAM_INBAND	5
#define DFS_PARAM_NOL           6
//5413 specific parameters
#define DFS_PARAM_ENRELPWR      7
#define DFS_PARAM_RELPWR        8
#define DFS_PARAM_ENUSEFIR128   9
#define DFS_PARAM_ENBLOCK       10 
#define DFS_PARAM_ENMAXRSSI     11 
#define DFS_PARAM_ENRELSTEP     12 
#define DFS_PARAM_RELSTEP       13
#define DFS_PARAM_MAXLEN        14

struct dfs_ioctl_params {
	int32_t		dfs_firpwr;	/* FIR pwr out threshold */
	int32_t		dfs_rrssi;	/* Radar rssi thresh */
	int32_t		dfs_height;	/* Pulse height thresh */
	int32_t		dfs_prssi;	/* Pulse rssi thresh */
	int32_t		dfs_inband;	/* Inband thresh */
	u_int32_t	dfs_enrelpwr;	/* enable/disable relative power check */
	u_int32_t	dfs_relpwr;	/* Relative power threshold in 0.5dB steps */
	u_int32_t	dfs_enusefir128;/* en/dis using the average in-band power measured over 128 cycles */
	u_int32_t	dfs_enrelstep;	/* en/dis pulse relative step check */
	u_int32_t	dfs_relstep;	/* Pulse Relative step threshold in 0.5dB steps */
	u_int32_t	dfs_maxlen;	/* Max length of radar sign in 0.8us units */
	u_int32_t	dfs_enblock;	/* Enable to block radar check if pkt detect is done via OFDM
					   weak signal detect or pkt is detected immediately after tx
					   to rx transition */
	u_int32_t	dfs_enmaxrssi;	/* Enable to use the max rssi instead of the last rssi during 
					   fine gain changes for radar detection */
};

#define	DFS_IOCTL_PARAM_NOVAL	-65535
