/*
 * Copyright (c) 2002-2005 Atheros Communications, Inc.
 * All rights reserved.
 *
 */

#include "opt_ah.h"

#ifdef AH_SUPPORT_AR5211

#include "ah.h"
#include "ah_internal.h"

#include "ar5211/ar5211.h"
#include "ar5211/ar5211reg.h"
#include "ar5211/ar5211desc.h"
#include "ar5211/ar5211phy.h"

HAL_BOOL
ar5211HaveRadarEvent(struct ath_hal *ah)
{

	return AH_FALSE;
}

HAL_BOOL
ar5211ProcessRadarEvent(struct ath_hal *ah, HAL_CHANNEL *chan)
{
	return AH_FALSE;
}

u_int32_t
ar5211CheckRadarNol(struct ath_hal *ah, HAL_CHANNEL *chans, u_int32_t nchans)
{
	return 0;
}

HAL_BOOL
ar5211RadarWait(struct ath_hal *ah, HAL_CHANNEL *chan)
{
	struct ath_hal_5211 *ahp = AH5211(ah);

	ahp->ah_curchan.privFlags |= CHANNEL_DFS_CLEAR;
	chan->privFlags |= CHANNEL_DFS_CLEAR;
	chan->channel = ahp->ah_curchan.channelFlags;
	chan->privFlags  = ahp->ah_curchan.privFlags;
	chan->maxRegTxPower = ahp->ah_curchan.maxRegTxPower;
	return AH_FALSE;
}

HAL_STATUS
ar5211RadarAttach(struct ath_hal *ah)
{
	return HAL_OK;
}

void
ar5211RadarDetach(struct ath_hal *ah)
{
}

#endif	/* AH_SUPPORT_AR5211 */
