/*
 * Copyright (c) 2005-2006 Atheros Communications, Inc.
 * All rights reserved.
 *
 */

#ifndef _PHYERR_H_
#define _PHYERR_H_

#include "../../dfs/dfs.h"

extern struct dfs_state *dfs_getchanstate(struct ath_softc *sc,
					  u_int8_t *index);
extern int dfs_process_radarevent(struct ath_softc *sc, HAL_CHANNEL *chan);
extern u_int32_t dfs_check_nol(struct ath_softc *sc, HAL_CHANNEL *chans,
			       u_int32_t nchans);
extern int dfs_attach(struct ath_softc *sc);
extern void dfs_detach(struct ath_softc *sc);
extern void ath_ar_enable(struct ath_softc *sc);
extern int dfs_radar_enable(struct ath_softc *sc);
extern void ath_process_phyerr(struct ath_softc *sc, struct ath_desc *ds,
			       u_int64_t fulltsf);
extern void dfs_process_ar_event(struct ath_softc *sc, HAL_CHANNEL *chan);
extern int dfs_set_thresholds(struct ath_softc *sc, const u_int32_t threshtype,
			      const u_int32_t value);
extern int dfs_get_thresholds(struct ath_softc *sc, HAL_PHYERR_PARAM *param);

#endif /* _PHYERR_H_ */









